Index: apt/apt-pkg/packagemanager.cc
===================================================================
--- apt.orig/apt-pkg/packagemanager.cc	2009-11-10 17:27:12.000000000 +0200
+++ apt/apt-pkg/packagemanager.cc	2009-11-10 17:27:55.000000000 +0200
@@ -299,6 +299,14 @@
    if (OList.OrderConfigure() == false)
       return false;
    
+   if (List->IsFlag(Pkg,pkgOrderList::Configured) == true)
+     {
+       // Pkg got configured during DepAdd.  That happens when DepAdd
+       // causes SmartUnpack to be called for a package that has a
+       // pre-dependency on us.
+       return true;
+     }
+
    // Perform the configuring
    for (pkgOrderList::iterator I = OList.begin(); I != OList.end(); I++)
    {
@@ -370,12 +378,21 @@
 	    // Not the install version 
 	    if (Cache[Pkg].InstallVer != *I || 
 		(Cache[Pkg].Keep() == true && Pkg.State() == PkgIterator::NeedsNothing))
-	       continue;
-	    
-	    if (List->IsFlag(Pkg,pkgOrderList::UnPacked) == true)
-	       Bad = !DepAdd(OList,Pkg,Depth);
+              continue;
+
 	    if (List->IsFlag(Pkg,pkgOrderList::Configured) == true)
-	       Bad = false;
+              {
+                Bad = false;
+              }
+            else if (List->IsFlag(Pkg,pkgOrderList::UnPacked) == true)
+              {
+                Bad = !DepAdd(OList,Pkg,Depth);
+              }
+            else
+              {
+                // Not even unpacked
+                Bad = !SmartUnPack (Pkg) || !DepAdd(OList,Pkg,Depth);
+              }
 	 }
       }
       
